

Imports System.IO.Ports

Public Class Form1
    Delegate Sub SetTextCallback(ByVal [text] As String)
    Dim Start_F As Boolean = False
    Dim End_F As Boolean = True
    Dim RCData(20, 3) As Integer 'Mlf[^
    Dim SumRCData(20, 3) As Integer 'ZMlf[^
    Dim count As Integer = 0
    Dim countN As Integer = 16


    Private Sub UpdateCOMPortList()
        Dim s As String
        Dim i As Integer
        Dim foundDifference As Boolean

        i = 0
        foundDifference = False
        If lstCOMPorts.Items.Count = SerialPort.GetPortNames().Length Then
            For Each s In SerialPort.GetPortNames()
                If lstCOMPorts.Items(i).Equals(s) = False Then
                    foundDifference = True
                End If
                i = i + 1
            Next s
        Else
            foundDifference = True
        End If
        If foundDifference = False Then
            Exit Sub
        End If
        lstCOMPorts.Items.Clear()
        For Each s In SerialPort.GetPortNames()
            lstCOMPorts.Items.Add(s)
        Next s
        lstCOMPorts.SelectedIndex = 0
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim i As Integer

        UpdateCOMPortList()
        If count < countN Then
            If Start_F = True And End_F = True Then
                SerialPort1.Write("AA#0#")
                End_F = False
            End If
        Else
            'txtDataReceived.Text = ""
            count = 0
            For i = 0 To 12
                SumRCData(i, 1) = 0
                SumRCData(i, 2) = 0
            Next
        End If

    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        Try
            SerialPort1.PortName = lstCOMPorts.Items(lstCOMPorts.SelectedIndex).ToString()
            SerialPort1.Open()
            btnConnect.Enabled = False
            lstCOMPorts.Enabled = False
            btnClose.Enabled = True

            txtDataReceived.Clear()
            txtDataReceived.AppendText("Connected." + vbCrLf)
        Catch ex As Exception
            btnClose_Click(Me, e)

        End Try
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        btnClose.Enabled = False
        btnConnect.Enabled = True
        lstCOMPorts.Enabled = True

        Try
            SerialPort1.DiscardInBuffer()
            SerialPort1.DiscardOutBuffer()
            SerialPort1.Close()
        Catch ex As Exception

        End Try
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim i As Integer
        Dim CalText As String = ""
        Dim RT As Double
        Dim RA0, RA1 As Integer





        Try
            Dim ReceivedText As String = SerialPort1.ReadExisting()
            Dim N As Integer = ReceivedText.Length
            IN_FM(ReceivedText)
            For i = 0 To 12
                SumRCData(i, 1) = SumRCData(i, 1) + RCData(i, 1)
                SumRCData(i, 2) = SumRCData(i, 2) + RCData(i, 2)
            Next

            If count = countN - 1 Then
                For i = 0 To 12
                    RT = SumRCData(i, 1) / SumRCData(i, 2) - 1.0
                    RA0 = SumRCData(i, 1) / countN
                    RA1 = SumRCData(i, 2) / countN
                    CalText = CalText & i.ToString() & vbTab & RT.ToString("0.000") & vbTab & RA0.ToString() & vbTab & RA1.ToString() & vbCrLf
                Next

                SetText(CalText)

            End If



            'SetText(ReceivedText)

            


            count = count + 1
            End_F = True

        Catch ex As Exception
            btnClose_Click(Me, e)
        End Try

    End Sub

    Private Sub SetText(ByVal [text] As String)
        If txtDataReceived.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)
            Invoke(d, New Object() {[text]})
        Else
            txtDataReceived.Text = text
            'txtDataReceived.AppendText(text)
        End If
    End Sub

    Private Sub btnSendData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSendData.Click
        Start_F = True
    End Sub

    Private Sub Form1_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Start_F = False
    End Sub
    Sub IN_FM(ByRef Str As String)
        Dim RData(20) As String '1z`
        Dim CData(20) As String '1z`
        Dim i, j As Integer

        i = 0
        Dim stArrayData As String() = Str.Split(vbLf)
        Try
            For Each stData As String In stArrayData
                Dim CArrayData As String() = stData.Split(vbTab)
                j = 0
                For Each CstData As String In CArrayData
                    'MessageBox.Show(CstData)
                    RCData(i, j) = Integer.Parse(CstData)
                    j = j + 1
                Next CstData
                i = i + 1
            Next stData
        Catch ex As Exception
        End Try
    End Sub
End Class
